// part of KSUDOKU - by Francesco Rossi <redsh@email.it> 2005
#ifndef SUDOKU_SOLVER_H
#define SUDOKU_SOLVER_H


#define ITERATE(i,s) for(int ((i))=0; ((i))<((s)); ((i))++)
#define RANDOM(x) random() % ((x))
#define SUDOKU_HARDEST -1
#define SUDOKU_HARD    0
#define SUDOKU_MEDIUM  1
#define SUDOKU_EASY    2
#define LEVINC         2

#include <stdio.h>

/**
@author Francesco Rossi
*/

#include <math.h>
//#include "sudoku_types.h"
// SUDOKU PUZZLE SOLVER BASIC ALGORITHM - BY FRANCESCO ROSSI 2005 redsh@email.it
class skBase
{
public:
	int base;
	int order;
	int size;
	char zerochar;
	void setorder(int k){order = k; base = (int) sqrt(order); size = order*order;if(order>9) zerochar = 'a'-1; else zerochar = '0';};
	skBase(int i=9){setorder(i);};
};
class skPuzzle : public skBase
{
public:
	unsigned char numbers[256];
	unsigned char flags[256][17];
	skPuzzle(int oi=9) : skBase(oi)
	{
		ITERATE(i,size)
		{ 
			numbers[i]=0; 
			ITERATE(j,order+1) flags[i][j]=1;
		}
		
	}
};
class skGraph  : public skBase
{
public:
	unsigned char graph[256][256];
	unsigned char optimized_d[256];
	unsigned char optimized[256][256]; //pointer-style list of connected nodes

	skGraph(int o=9) : skBase(o)
	{
		ITERATE(i,size)
		{
			ITERATE(j,40) graph[i][j]=0; 
			optimized_d[i]=0;
		}
	}
};

class skSolver{
public:
    skSolver(int n=9);
    ~skSolver();
	
public:
	skGraph* g;
	int size;
	int order;
	char zerochar;
	
public:
	int remove_numbers(skPuzzle* p, int difficulty);
	int solve(skPuzzle* puzzle,  int max_solutions = 1, skPuzzle* out_solutions = 0);
	int solve_engine(skPuzzle *s,  int& solutions, skPuzzle* out_solutions = 0, int maxsolutions = 1, int last_add=-1, int dynindex=-1, int dynvalue=0);
	int init();
	void copy(skPuzzle* dest, skPuzzle* src);
};

#endif

